<template>
    <div>

        <div class="titulo">
            <div class="ruta">
                <v-breadcrumbs :items="breadcrumbs">
                <template v-slot:divider>
                    <v-icon>mdi-chevron-right</v-icon>
                </template>
                </v-breadcrumbs>
            </div>
            <strong>Administrador de Visitas</strong>
        </div>
        
        <div class="contSecc">
           <v-btn color="primary" dark @click="showDialog"><v-icon color ='black' style="paddingLeft: 15px" small left>mdi-plus</v-icon><strong>Nueva visita</strong></v-btn>
         <v-row>
            <v-col>
                <v-sheet height="64">
                    <v-toolbar flat color="white">
                        <v-btn outlined text medium color="grey darken-2" @click="prev(); initAsignacionesDia()" class="btnRadius_L">
                            <v-icon small>mdi-chevron-left</v-icon>
                        </v-btn>
                        <v-btn outlined text medium color="grey darken-2" @click="next(); initAsignacionesDia()" class="btnRadius_R" >
                            <v-icon small>mdi-chevron-right</v-icon>
                        </v-btn>
                        <v-spacer></v-spacer>
                        <v-toolbar-title style="margin: 15px">
                            {{formatDate()}}
                        </v-toolbar-title>
                        <v-spacer></v-spacer>

                            <v-btn color="#fff" class ="btnRadius_L" style="padding: 0px 30px 0px 30px;" @click="goToMes()">
                            <strong>Mes</strong>
                            </v-btn>
                            <v-btn color="#fff" class = "btnRadius_NO" style="padding: 0px 30px 0px 30px;" @click="goToSemana()" >
                            <strong>Semana</strong>
                            </v-btn>            
                            <v-btn color="primary" class ="btnRadius_R" style="padding: 0px 30px 0px 30px; ">
                            <strong>Dia</strong>
                            </v-btn>
                    </v-toolbar>
                </v-sheet>
      <v-sheet height="600" outlined style="overflow-y : auto; overflow-x : hidden;">
            <v-simple-table >
                <template v-slot:default>
                    <thead>
                        <tr>
                        <th style="background-color: #F9E79F; font-size : 14px" class="text-center" >{{getNameDay()}}</th>                    
                        </tr>
                    </thead>
                    <tbody v-if="asignacionesDia.length > 0" >
                        <tr  v-for="(asignacion,indexAsignacion) in asignacionesDia" 
                            :key="indexAsignacion"
                            >
                            <td style="paddingLeft: 15px" >
                                <v-row>
                                    <v-col >
                                        <v-row>
                                            <v-icon :color ="getColor(asignacion.idNegocio)"  x-small left>mdi-checkbox-blank-circle</v-icon> 
                                            <strong >{{asignacion.idCeco}} - {{asignacion.ceco}} </strong>          
                                        </v-row>
                                        <v-row>
                                            {{asignacion.nombreFase}} ({{asignacion.nombreProyecto}})
                                        </v-row>
                                        <v-row centered>
                                        {{asignacion.nombreResponsable}} 
                                        
                                        <v-spacer></v-spacer> 

                                        <v-btn text medium><v-icon>mdi-pencil</v-icon>  <u>Editar Visita</u> </v-btn>
                                        <v-btn text medium><v-icon>mdi-delete</v-icon>  <u>Eliminar</u></v-btn>
                                        
                                        </v-row>

                                    </v-col>
                                    
                                </v-row>  
                            </td>    
                        </tr>
                    </tbody>
                    <tbody v-else>
                        <tr style="background-color: #F8F9F9; height: 100px">
                            <td > 
                                <v-row >
                                    <v-col align="center" >
                                        <v-icon > mdi-calendar-blank</v-icon><strong style="margin-left: 15px">No hay asignaciones</strong>
                                    </v-col>
                                </v-row>
                            </td>
                        </tr>

                    </tbody>

                </template>
        </v-simple-table>
      </v-sheet>    
        
        </v-col>
        </v-row>

        <dialog-asignacion ref="dialogAsingacionRef">
        </dialog-asignacion>


        <simbologias></simbologias>
    
    </div>
        
         
       

    </div>
</template>
<script>
import router from "@/router";
import store from "@/store";
import moment from "moment";
import DialogAsignacion from '@/views/secure/infraestructura/asignaciones/DialogAsignacion'
import Simbologias from '@/views/secure/infraestructura/components/Simbologias';
const axiosChecklist = store.state.axiosChecklist;
const serviceCommons = store.state.serviceCommons;
export default {
    components: {
        DialogAsignacion,
        Simbologias
    },
    created() {
      const dataTransfer = serviceCommons.base64ToObject(this.$route.params.dataTransfer);
      
      this.dia = dataTransfer.dia;

      this.fecha = new Date(this.dia);

      this.asignacionesMes = dataTransfer.eventos;

      this.initAsignacionesDia();

    },
    data() {
        return {
            dia: "",
            fecha : null,
            asignacionesDia : [],
            asignacionesMes : [],
            breadcrumbs: [
                {
                text: "Plataforma de Franquicia",
                disabled: false,
                exact: true,
                to: {
                    name: "home"
                }
                },
                {
                text: "Infraestructura",
                disabled: false,
                exact: true,
                to: {
                    name: "home"
                }
                },
                {
                text: "Asignación de Visita",
                disabled: false,
                exact: true,
                to: {
                    name: "modelo_franquicia_info_recorridos"
                }
                }
            ]
        }
    },
    methods: {
        goToMes(){
            router.push({
                name : "modelo_franquicia_asignacion_adm_asigna",
                
            });
        },
        goToSemana (){
            var objToPass = {
            asignaciones : this.asignacionesMes  
            };

            router.push({
                name : "modelo_franquicia_calendario_semana",
                params : {
                    dataTransfer : serviceCommons.objectToBase64(objToPass)
                }
            });
            
        },
        initAsignacionesDia(){

            this.asignacionesDia = [];

            Object.keys(this.asignacionesMes).forEach( (key) => {

                var asignacion = this.asignacionesMes[key];
                if(asignacion.start == this.dia){
                    this.asignacionesDia.push(asignacion);
                }

            });

        },
        showDialog() {
            this.$refs.dialogAsingacionRef.showDialog();
        },
        formatDate(){
            let fechaNueva = moment(this.fecha).add(1, 'day');
            moment.locale('es');
            fechaNueva.locale(false);
            return fechaNueva.format('LL');
        },
        getNameDay(){
            return moment(this.fecha).add(1,"day").format('dddd')
        },
        next(){
            let b = new Date(this.fecha);
            b.setDate(b.getDate() + 1);
            this.fecha = new Date(b);

            this.dia = moment(this.fecha).add(1,"day").format("YYYY-MM-DD");
            
        },
        prev(){
            let b = new Date(this.fecha);
            b.setDate(b.getDate() - 1);
            this.fecha = new Date(b);

            this.dia = moment(this.fecha).add(1,"day").format("YYYY-MM-DD");

            
        },
        getColor(negocio){
            var color  = "#000";

            if(negocio == "21"){
                color = "primary";
            }else if(negocio == "23"){
                color = "#191970";
            }else if(negocio == "25"){
                color = "#32CD32";
            }

            return color;

        }
    },

}
</script>
<style scoped>
.btnRadius_R{
  border-top-right-radius: 5px;
  border-bottom-right-radius: 5px;
  border-top-left-radius: 0px;
  border-bottom-left-radius: 0px;
}

.btnRadius_L{
  border-top-left-radius: 5px;
  border-bottom-left-radius: 5px;
  border-top-right-radius: 0px;
  border-bottom-right-radius: 0px;
}
</style>